// General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
// base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
// The model can simulate OLEDs, Perovskite cells, and OFETs.
// 
// Copyright (C) 2008-2020 Roderick C. I. MacKenzie
// All rights reserved.
// 
// https://www.gpvdm.com
// r.c.i.mackenzie at googlemail.com
// 
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the GPVDM nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sim.h"
#include <math.h>

void sim_ce(struct device *in)
{

double V=in->Vstart;
double Vstop=in->Vstop;
double Vstep=in->Vstep;
char out[1000];
int gothermal=FALSE;
int ittr=0;
FILE *train;

train=fopen("./ceescape.dat","w");
fclose(train);
	do
	{

		in->Vapplied=V;


		in->onvalue=in->Vapplied;

		sim_time(in);


		train=fopen("./ceescape.dat","a");
		fprintf(train,"%.20e %.20e %.20e %.20e \n",V,(mod(carrier_count_get_rn(in))+mod(carrier_count_get_rp(in)))/(mod(carrier_count_get_n(in))+mod(carrier_count_get_p(in))),carrier_count_get_n(in),carrier_count_get_p(in));
		fclose(train);

		sprintf(out,"V=%lf current = %e mA (%e A/m^2)\n",V,get_I(in)/1e-3,get_J(in));
		printdebug(out);

		//getchar();


		ittr++;



			V+=Vstep;
			dialog_set_progress ((in->Vstart+V)/(in->Vstop-in->Vstart));
			if ((Vstep>=0)&&(V>Vstop))
			{
				in->stop=TRUE;
			}

			if ((Vstep<0)&&(V<Vstop))
			{
				in->stop=TRUE;
			}

			if (get_equiv_V(in)>Vstop) break;


		if (in->stop==TRUE)
		{
			break;

		}

	}while(1);




}

